import click
import nmtutil
import os
import socket
import sys
from common.system import run_shell_command

import logging

logger = logging.getLogger(__name__)

@click.group(help="Manage hostname.")
@nmtutil.pass_context
def nmtmain(ctx, **kwargs):
    pass


@nmtmain.command(help="Set hostname")
@click.argument("name", type=click.STRING)
@nmtutil.pass_context
def set(ctx, name):
    #click.echo("Setting hostname = %s" % name)
    #ret,output = run_shell_command("echo %s %s" %(name,'tester'), use_sudo=True )

    #
    # TODO: add host name validationx
    ret,output = run_shell_command("hostnamectl set-hostname %s" %(name), use_sudo=True )

    if ctx.verbose:
        print ('rc:' + str(ret))

        print (output)

    if ret:
        logger.error('Cannot set a hostname ' + name )
        sys.exit(1)

    else:
        logger.info('Set a hostname: ' + name )


@nmtmain.command(help="Get hostname")
@nmtutil.pass_context
def get(ctx):
    #click.echo("Getting hostname")
    try: 
        host_name = socket.gethostname() 
        #host_ip = socket.gethostbyname(host_name) 
        print(host_name) 
        logger.info( 'Hostname: ' + host_name ) 
    except: 
        print("Unable to get Hostname") 
        logger.error("Unable to get Hostname")
        sys.exit(1)

